/* ------------------------------------------------------
	fileinfo.c	for typist
	1992-07-14  by T.Ogihara (ECIP Osaka Univ.)
------------------------------------------------------ */

#include <stdio.h>
#include "typist.h"

#define   RCMAX    32
#define   TLMAX    20

struct Lesson typeLessons[TLMAX];
BoolType HasHelp = FALSE;
char LastLesson = 0;
short LastNum = 1;

extern char *getenv();

static FILE *rc;
static StrType rcpath;
static char buf[RCMAX];

BoolType GetIndex()
{
    register int i;
    int j,k;
    char *a;
    StrType xpath;

    sprintf(xpath, "%s/index.typ", LessonDir);
    if ((rc = fopen(xpath, "r")) == NULL)
	return FALSE;
    i = 0;
    while(fgets(buf,RCMAX,rc) != NULL) {
	if (buf[0] == '#') /* comment */
	    continue;
	if (buf[0] == '?') { /* Help: must be the last */
	    typeLessons[i].nam = 'H';
	    typeLessons[i].num = 1;
	    typeLessons[i].fin = 0;
	    typeLessons[i].item = NULL;
	    i++;  HasHelp = TRUE;
	    break;
	}else {
	    typeLessons[i].nam = buf[0];
	    typeLessons[i].num = atoi(&buf[1]);
	    for (j=2; buf[j] != 0 && buf[j] != '\"'; j++) ;
	    if (buf[j] == 0) return FALSE;
	    for (k= ++j; buf[k] != 0 && buf[k] != '\"'; k++) ;
	    typeLessons[i].item = a = (char *)malloc(k - j + 1);
	    for (; j < k; j++,a++) *a = buf[j];
	    *a = 0;
	    typeLessons[i].fin = 0;
	}
	i++;
    }
    typeLessons[i].nam = 0;
    typeLessons[i].num = 0;
    typeLessons[i].fin = 0;
    typeLessons[i].item = NULL;
    return (i>0);
}

BoolType CheckLessonName(s)
    char *s;
{
    int i,n;

    if (s == NULL || s[0] == 0) return FALSE;
    for (i=0; typeLessons[i].nam; i++) {
	if (typeLessons[i].nam == s[0]) {
	    n = atoi(&s[1]);
	    return (n > 0 && n <= typeLessons[i].num)? TRUE: FALSE;
	}
    }
    return FALSE;
}


void read_rc()
{
    int ch, n;
    char *h;
    register struct Lesson *p;

    if ((h = getenv("HOME")) == NULL) return;
    sprintf(rcpath, "%s/%s", h, TYPISTRC);
    if ((rc = fopen(rcpath, "r")) == NULL) return;
    if (fgets(buf, RCMAX, rc) == NULL) return;
    LastLesson = buf[0];
    while (fgets(buf, RCMAX, rc) != NULL) {
	ch = buf[0];
	n = atoi(&buf[1]);
	for (p = typeLessons; p->item; p++) {
	    if (ch == p->nam) {
		p->fin = (p->num > n)? n: FINISHED;
		if (ch == LastLesson) LastNum = p->fin;
		break;
	    }
	}
    }
    (void) fclose(rc);
}

void write_rc()
{
    register struct Lesson *p;
    int n;

    if (rcpath[0] == 0 || LastLesson == 0) return;
    if ((rc = fopen(rcpath, "w")) == NULL) {
	fprintf(stderr,"ERROR: Can't write into \"%s\".\n", rcpath);
	return;
    }
    fprintf(rc,"%c\n", LastLesson);
    for (p = typeLessons; p->item; p++)
	if (n = p->fin) {
	    if (n > p->num) n = p->num;
	    fprintf(rc,"%c%d\n", p->nam, n);
	}
    (void) fclose(rc);
    LastLesson = 0;
}
