/* ------------------------------------------------------
	main.c	for typist
---------------------------------------------------------
	Original: D. Jason Penney (penneyj@slc.com)
	Tuned for ECIP NeXT: Takeshi Ogihara
		(ogihara@ayame.rd.ecip.osaka-u.ac.jp)
	Ver.1.0   1992-07-14
	Ver.1.1   1992-08-05	ESC  ->  Ctrl-F
	Ver.1.2   1994-11-10	for non-NeXT WS
	Ver.1.3   1994-12-09	REPEAT & BELL
------------------------------------------------------ */

#include "typist.h"

char *LessonDir = LESSONDIR;
#ifdef SILENT
BoolType loud = FALSE;	/* without BEEP */
#else
BoolType loud = TRUE;	/* use BEEP */
#endif

static void usage()
{
#ifdef JPN
    printf("\
Ȥ: typist [ץ] [lesson]\n\
ץ:\n\
    -q       Фʤ\n\
    -V       С\n\
    -Ldir    åǡΤǥ쥯ȥ\n\
Lesson:  å̾(t1, s3 ʤ)\n");
#else
    printf("\
Usage: typist [options] [lesson]\n\
Options:\n\
    -q       quiet mode\n\
    -V       print current version\n\
    -Ldir    specify lesson-data directory\n\
Lesson:  Lesson-name you want to do.\n");
#endif
    exit(1);
}

static void version()
{
    printf("\
Typist...\n\
    Original:  26 Nov 91,   D. Jason Penney (penneyj@slc.com)\n\
    Tuned for Japanese Users on WS:\n\
	       T. Ogihara (ogihara@rd.ecip.osaka-u.ac.jp)\n\
    Ver. 1.1  1992-08-05\tfor NeXT\n\
    Ver. 1.2  1994-11-08\tfor non-NeXT WS\n\
    Ver. 1.3  1994-12-08\trepeat key\n");
    exit(0);
}

main(argc, argv)
    int argc;
    char *argv[];
{
    register int i;
    char *lesson = NULL;

    for (i=1; i<argc; i++) {
	if (argv[i][0] != '-') {
	    lesson = argv[i];
	    break;
	}
	switch (argv[i][1]) {
	case 'q':
	    loud = FALSE;  break;
	case 'L':  /* DEBUG */
	    if (argv[i][2] <= ' ') {
		printf("Error: -L needs dir\n");
		exit(1);
	    }
	    LessonDir = &argv[i][2];
	    break;
	case 'V':
	    version(); break;
	default:
	    printf("Error: %s ?\n", argv[i]);
	    usage(); break;
	}
    }
    if (!GetIndex()) {
	printf("Error: can't get index for lessons.\n");
	exit(1);
    }
    typist(lesson);
}
